<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Available users</template>

      Click on username to edit<br>
      <a @click="dispatchToNew()">[Click here to add user]</a>
      <div>
        <b-alert
          :show="hasError"
          dismissible
          variant="danger"
        >{{ alertMessage }}</b-alert>
      </div>
      <div class="mydiv-tablealign">
        <table class="table table-bordered">
          <thead>
            <tr>
              <th>Login</th>
              <th>Role</th>
              <th>Department</th>
            </tr>
          </thead>
          <tr v-for="user in users" class="static" v-bind:key="user">
            <td @click="dispatchToUser(user)">{{user.name}}</td>
            <td @click="dispatchToUser(user)">{{user.role}}</td>
            <td @click="dispatchToUser(user)">{{user.unit ? user.unit : "-"}}</td>
          </tr>
        </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  data() {
    return {
      users: [],
      alertMessage: "Request error",
      hasError: false
    };
  },
  created() {
    this.loadItems()
  },
  beforeRouteUpdate (_, __, next) {
    this.loadItems();
    next();
  },
  methods: {
    loadItems() {
      AXIOS.get(`/admin/users`, {})
      .then(
        response => {
          console.log(response);
          this.users = response.data;
          this.hasError = false;
        },
        error => {
          console.log(error);
          this.$data.alertMessage =
            error.response.data.length < 150
              ? error.response.data
              : "Request error. Please, report this error website owners";
          this.hasError = true;
          this.groups = [];
        }
      )
      .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.groups = [];
          this.hasError = true;
        });
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    dispatchToUser(user) {
      this.$router.push({ name: "EditUser", params: { userName: user.name } });
    },
    dispatchToNew() {
      this.$router.push({ name: "NewUser" });
    }
  }
};
</script>

<style>
.mydiv-tablealign{
	text-align:center
}
</style>